<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8">
		<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0, minimum-scale=1.0">
		<title>fanfiction.net to kindle</title>
	</head>
	<body>
		<h3>fanfiction.net to kindle</h3>
		Source: <a href="https://gitlab.com/dkx/projects/ffnet-to-kindle" target="_blank" rel="noopener">gitlab.com/dkx/projects/ffnet-to-kindle</a>

		<hr>

		Book ID: <input type="number" id="input-id" min="1"><br>
		Email: <input type="email" id="input-email"><br>
		<label><input type="checkbox" id="include-headlines" checked> Include chapters' headlines</label>

		<hr>

		<small>Download URL: <a href="#" id="url-download"></a></small><br>
		<small>Send URL: <a href="#" id="url-send"></a></small><br>

		<script type="text/javascript">
			var urlDownload = document.getElementById('url-download');
			var urlSend = document.getElementById('url-send');
			var inputId = document.getElementById('input-id');
			var inputEmail = document.getElementById('input-email');
			var inputIncludeHeadlines = document.getElementById('include-headlines');

			var baseUrl = window.origin;
			var currentId = '?';
			var currentEmail = '?';
			var attrs = {
				headlines: 'true',
			};

			function writeUrls() {
				var urlAttrs = [];
				for (var key in attrs) {
					if (attrs.hasOwnProperty(key)) {
						urlAttrs.push(key + '=' + attrs[key]);
					}
				}

				var append = urlAttrs.length ? ('?' + urlAttrs.join('&')) : '';

				urlDownload.innerText = baseUrl + '/ff/' + currentId + '/download' + append;
				urlSend.innerText = baseUrl + '/ff/' + currentId + '/send/' + currentEmail + append;
				urlDownload.setAttribute('href', urlDownload.innerText);
				urlSend.setAttribute('href', urlSend.innerText);
			}

			writeUrls();

			inputId.addEventListener('input', function() {
				currentId = inputId.value === '' ? '?' : inputId.value;
				writeUrls();
			});

			inputEmail.addEventListener('input', function() {
				currentEmail = inputEmail.value === '' ? '?' : inputEmail.value;
				writeUrls();
			});

			urlDownload.addEventListener('click', function(e) {
				if (currentId === '?') {
					e.preventDefault();
				}
			});

			urlSend.addEventListener('click', function(e) {
				if (currentId === '?' || currentEmail === '?') {
					e.preventDefault();
				}
			});

			inputIncludeHeadlines.addEventListener('change', function() {
				if (inputIncludeHeadlines.checked) {
					attrs.headlines = 'true';
				} else if (typeof attrs.headlines !== 'undefined') {
					delete attrs.headlines;
				}

				writeUrls();
			});
		</script>
	</body>
</html>
